rule_files:
  - ../k8s/base/alert.rules

evaluation_interval: 1m

tests:
  - interval: 1m
    # Input mock data that will be used in tests below.
    input_series:
      - series: 'kube_hpa_status_condition{condition="ScalingLimited",status="true",hpa="member-api-hpa",namespace="xand",instance="prometheus.xand.services:443"}'
        # 7 0s followed by 7 1s and 3 0s
        values: '0+0x6 1+0x6 0+0x2'
      - series: 'kube_hpa_status_condition{condition="ScalingLimited",status="true",hpa="validator-hpa",namespace="xand",instance="prometheus.xand.services:443"}'
        # 15 0s
        values: '0+0x14'
      - series: 'kube_hpa_status_condition{condition="ScalingLimited",status="true",hpa="validator-whitelister-hpa",namespace="xand",instance="prometheus.xand.services:443"}'
        # 11 1s followed by 5 0s
        values: '1+0x10 0+0x4'

    # Actual tests against mock data above.
    alert_rule_test:
      # At the 4th minute which is the 5th interval we expect validator-whitelister to be at 0 as shown above.
      - eval_time: 4m
        alertname: HPA Scaling Limited
        exp_alerts:
          - exp_labels:
              team: devops
              hpa: validator-whitelister-hpa
              namespace: xand
              instance: prometheus.xand.services:443
            exp_annotations:
              summary: "HPA named validator-whitelister-hpa in xand namespace on prometheus.xand.services:443 has reached scaling limited state"

      # At the 10th minute which is the 11th interval we expect member-api and validator-whitelister to be at 0 as shown above.
      - eval_time: 10m
        alertname: HPA Scaling Limited
        exp_alerts:
          - exp_labels:
              team: devops
              hpa: member-api-hpa
              namespace: xand
              instance: prometheus.xand.services:443
            exp_annotations:
              summary: "HPA named member-api-hpa in xand namespace on prometheus.xand.services:443 has reached scaling limited state"
          - exp_labels:
              team: devops
              hpa: validator-whitelister-hpa
              namespace: xand
              instance: prometheus.xand.services:443
            exp_annotations:
              summary: "HPA named validator-whitelister-hpa in xand namespace on prometheus.xand.services:443 has reached scaling limited state"

      - eval_time: 14m
        alertname: HPA Scaling Limited
        # No expected alerts
